﻿Type=StaticCode
Version=1.2
ModulesStructureVersion=1
B4R=true
@EndOfDesignText@


Sub Process_Globals
	Private bc As ByteConverter
	Private Astream As AsyncStreams	
	
	Private server As WiFiServerSocket
	Private eeprom As EEPROM
	Private const MAGIC_EEPROM As Byte = 123
	Private ethClient As EthernetSocket
'	Private xxx As WebSocketClient
	
	 

End Sub


Public Sub WifiAPmodeStart(ap_user As String,ap_pass As String)
	Log("***Public Sub WifiAPmodeStart")
	Log("StartAP:",ap_user,"||",ap_pass," ", Main.WiFi.StartAccessPoint2(ap_user,ap_pass))
	Log("My AP ip: ", Main.WiFi.AccessPointIp)
	Log("local ip:",Main.WiFi.LocalIp)
	server.Initialize(80, "server_NewConnection")
	server.Listen
End Sub





Public Sub Connect(unused As Byte)
	Log("***Public Sub Connect")
	
   If ethClient.ConnectHost("example.com", 80) = False Then
     Log("trying to connect again")
     CallSubPlus("Connect", 1000, 0)
     Return
   End If
   Log("Connected to server")
   Astream.Initialize(ethClient.Stream, "Astream_NewData", "Astream_Error")
   
   Dim eol() As Byte = Array As Byte(13, 10)
   Astream.Write("GET / HTTP/1.1".GetBytes)
   Astream.Write(eol)
  Astream.Write("Host: www.example.com".GetBytes)
   Astream.Write(eol)
  Astream.Write("Connection: close".GetBytes)
   Astream.Write(eol)
   Astream.Write(eol)
   Log("***********CONNECT COMPLADE*************")
End Sub

Private Sub Server_NewConnection (NewSocket As WiFiSocket)
	Log("***Private Sub Server_NewConnection")
	Astream.Initialize(NewSocket.Stream, "astream_NewData", "astream_Error")
End Sub

Private Sub Astream_NewData (Buffer() As Byte)
    Log("***Private Sub Astream_NewData")
	'Log(Buffer)
	
If bc.IndexOf(Buffer, "<DT>") <> -1 Then
			Log("tarih okundu2")
			Main.ww=True	
	End If


' Log ("L:", Buffer.Length)
	If bc.IndexOf(Buffer, "GET") <> -1 Then
		'-------------------
		If bc.IndexOf(Buffer, "<DT>") <> -1 Then
			Log("tarih okundu2")
			Main.ww=True	
		End If
		'-----------------------------------------
		If bc.IndexOf(Buffer, "/set") <> -1 Then
			
			Dim ssid = "", password  = "" As String
			Dim i1 As Int = 0
			Dim i2 As Int = 0
			For Each b1() As Byte In bc.Split(Buffer, " ")
				If i1 = 1 Then
					For Each b2() As Byte In bc.Split(b1, "/")
						Select i2
							Case 2
								ssid = bc.StringFromBytes(b2)
							Case 3
								password = bc.StringFromBytes(b2)
						End Select
						i2 = i2 + 1
					Next
					
				End If
				i1 = i1 + 1
			Next
			Log(StackBufferUsage)
			Astream.Write("HTTP/1.1 200").Write(CRLF)
			Astream.Write("Content-Type: text/html").Write(CRLF).Write(CRLF)
			Astream.Write("<script>setTimeout(function(){location.href=""http://192.168.4.1""} , 20000);</script>")
			Astream.Write("WiFi set to: ").Write(ssid).Write(", password: ").Write(password).Write("<br/>Please wait...")
			SaveNetworkDetails(ssid, password)
			CallSubPlus("ConnectWifi", 500, 0)
		'-----------------------------------------------------
		Else If bc.IndexOf(Buffer, "/xxx ") <> -1 Then
			Log("xxx")
			Astream.Write("HTTP/1.1 200").Write(CRLF).Write(CRLF)
			If Main.WiFi.IsConnected Then
				If Main.ww Then
					Astream.Write("DENEME BAŞARILI").Write(CRLF)
					Astream.Write("Kartek tube bağlanacak").Write(CRLF)
					'Astream.Write("ESP8266 IP address: ").Write(Main.WiFi.LocalIp)
					Log("***************KARTEK BAĞLANACAK********************************")
					Main.ww=False
					'Connect(1)
					WebDateTime.Connectweb(1) 
				Else
					
					Log("******* example waiting*********")
					Log("Buffer:",Buffer)
				End If
			Else
				Astream.Write("Not connected!")
			End If
		'---------------------------------------------
		'---------------------\merkezwifiset--------------------------------
		Else If bc.IndexOf(Buffer, "/merkezwifiset") <> -1 Then
			Log("xxx makine set")
			Astream.Write("HTTP/1.1 200").Write(CRLF).Write(CRLF)
			
					Dim i1 As Int = 0
					Dim i2 As Int = 0
					For Each b1() As Byte In bc.Split(Buffer, " ")
						If i1 = 1 Then
							For Each b2() As Byte In bc.Split(b1, "/")
								Select i2
									Case 2
										'Main.Merkez_wifi(0) = bc.StringFromBytes(b2)
										bc.ArrayCopy(b2,Main.Merkez_wifi_SSID)
									Case 3
										'Main.Merkez_wifi(1)  = bc.StringFromBytes(b2)
										bc.ArrayCopy(b2,Main.Merkez_wifi_pass)
								End Select
								i2 = i2 + 1
							Next
							
						End If
						i1 = i1 + 1
					Next
					Write32(Main.Merkez_wifi_SSID,3)
					Write32(Main.Merkez_wifi_Pass,4)
					'SaveNetworkDetails(Main.Merkez_wifi_SSID,Main.Merkez_wifi_Pass)
					Log("wifi adı güncellendi")
					Astream.Write("merkze wifi güncelelndi adı guncellendi")
			
		'---------------------------------------------		
		
		'---------------------makineset--------------------------------
		Else If bc.IndexOf(Buffer, "/makineset") <> -1 Then
			Log("xxx makine set")
			Astream.Write("HTTP/1.1 200").Write(CRLF).Write(CRLF)
			
					Dim i1 As Int = 0
					Dim i2 As Int = 0
					For Each b1() As Byte In bc.Split(Buffer, " ")
						If i1 = 1 Then
							For Each b2() As Byte In bc.Split(b1, "/")
								Select i2
									Case 2
										'Main.Makine1 = bc.StringFromBytes(b2)
										bc.ArrayCopy(b2,Main.Makine1)
									Case 3
										'Main.Makine(1) = bc.StringFromBytes(b2)
										bc.ArrayCopy(b2,Main.Makine2)
								End Select
								i2 = i2 + 1
							Next
							
						End If
						i1 = i1 + 1
					Next
					
					Write32(Main.Makine1,1)
					Write32(Main.Makine2,2)
					Log("makine adı güncellendi")
					Astream.Write("makine adı guncellendi")
			
		'---------------------------------------------	
		'-----------------WIFI Şİ------------------------------------
		Else If bc.IndexOf(Buffer, "/info ") <> -1 Then
			Astream.Write("HTTP/1.1 200").Write(CRLF).Write(CRLF)
			Log(">>>>>>>>>1",Main.Sensor_Kapi)
			
				Log(">>>>>>>>>2")
				Astream.Write("<html><title>Kartek IoT System v.1.0.</title><body>").Write(CRLF)
				Log(Main.Makine1,Main.Makine2)
				'
				Astream.Write("Makine No: ").Write(Main.Makine1).Write("<br/>").Write(CRLF)
				Astream.Write("Makine Adı: ").Write(Main.Makine2).Write("<br/>").Write(CRLF)
				Log("wen:",2)
				Astream.Write("-----------------------------------------------").Write("<br/>").Write(CRLF)
				Astream.Write("Merkez Wifi SSID: ").Write(Main.Merkez_wifi_SSID).Write("<br/>").Write(CRLF)
				Astream.Write("Merkez Wifi Password: ").Write(Main.Merkez_wifi_Pass).Write("<br/>").Write(CRLF)
				Log("wen:",3)
				Delay(100)
				Dim sx As String
				If Main.WiFi.IsConnected Then sx="CONNECT" Else sx="DISCONNECT"
				Log("wen:",4)
				Astream.Write("Merkez Wifi Status: ").Write(sx).Write("<br/>").Write(CRLF)
				Astream.Write("Merkez Wifi IP: ").Write(Main.WiFi.LocalIp).Write("<br/>").Write(CRLF)
				Astream.Write("-----------------------------------------------").Write("<br/>").Write(CRLF)
				Log("wen:",5)
				Delay(100)
				Log("wen:",51)
				Astream.Write("Durum: ").Write("Çalışıyor").Write("<br/>").Write(CRLF)
				Log("wen:",52)
				Astream.Write("Sayac: ").Write("1453 adet").Write("<br/>").Write(CRLF)	
				Log("wen:",53)			
				Astream.Write("-----------------------------------------------").Write("<br/>").Write(CRLF)
				Log("wen:",54)	
				Delay(100)	
				Astream.Write("Kapı sensoru: ").Write("True").Write("<br/>").Write(CRLF)
				Log("wen:",55)	
				Delay(300)	
				Astream.Write("Motor sensoru: ").Write("False").Write("<br/>").Write(CRLF)
				Log("wen:",56)	
				Delay(300)	
				Astream.Write("Sayac sensoru: ").Write("True").Write("<br/>").Write(CRLF)
				Log("wen:",6)
				Astream.Write("-----------------------------------------------").Write("<br/>").Write(CRLF)
				Log("wen:",61)
				Delay(300)
				Astream.Write("--------------AYAR SET KOMUTLARI-------------------------").Write("<br/>").Write(CRLF)
				Log("wen:",62)
				Delay(100)
				Astream.Write("..ip../makineset/***makineno***/****makine adi****").Write("<br/>").Write(CRLF)
			    Log("wen:",63)
				Delay(300)
				Astream.Write("..ip../merkezwifiset/***ssid***/****password****").Write("<br/>").Write(CRLF)
				Log("wen:",7)
				Delay(300)
				Astream.Write("..ip../tarihset/**gun**/**ay**/***yil***").Write("<br/>").Write(CRLF)
				Log("wen:",71)
				Delay(300)
				Astream.Write("xxx").Write("<br/>")
				Astream.Write("..ip../saatset/--saat--/--dakika--").Write("<br/>").Write(CRLF)
				Log("wen:",72)
				Delay(300)
				Astream.Write("yyy").Write("<br/>")
				Log("wen:",73)
				Delay(300)
				Astream.Write("*** durum yerine, TRUE icin T, FALSE icin F yazin.").Write("<br/>").Write(CRLF)
				Log("wen:",74)
				Delay(300)
			
				Astream.Write("..ip../sensorkapiset/**durum**").Write("<br/>").Write(CRLF)
				Astream.Write("..ip../sensormotorset/**durum**").Write("<br/>").Write(CRLF)
				Log("wen:",74)
				Delay(300)
				Astream.Write("..ip../sensorsayacset/**durum**").Write("<br/>").Write(CRLF)
				Astream.Write("..ip../sayacne").Write("<br/>").Write(CRLF)
				Astream.Write("..ip../listwifi").Write("<br/>").Write(CRLF)
			Log("wen:",8)
		'---------------------------------------------	
		'-----------------WIFI Şİ------------------------------------
		Else If bc.IndexOf(Buffer, "/reset ") <> -1 Then
			Astream.Write("HTTP/1.1 200").Write(CRLF).Write(CRLF)
			If Main.WiFi.IsConnected Then
				Astream.Write("sistem resetlendi...").Write(CRLF)
				eeprom.WriteBytes("000", 0)
			Else
				Astream.Write("Not connected!")
			End If
		'---------------------------------------------
		'-----------------WIFI Şİ------------------------------------
		Else If bc.IndexOf(Buffer, "/listwifi") <> -1 Then
			Astream.Write("HTTP/1.1 200").Write(CRLF).Write(CRLF)
			Astream.Write("<html><body>")
			For i=0 To Main.WiFi.Scan-1
				Log("Wifi-",i,": ",Main.WiFi.ScannedSSID(i))
				Astream.Write(Main.WiFi.ScannedSSID(i)).Write("<br/>").Write(CRLF)
			Next
			Astream.Write("... list tamalandı<br/>").Write(CRLF)
		'---------------------------------------------	
		Else If bc.IndexOf(Buffer, " / ") <> -1 Then
			Astream.Write("HTTP/1.1 200").Write(CRLF).Write(CRLF)
			If Main.WiFi.IsConnected Then
				Dim r As String	
				r=Rnd(1,100)
				Astream.Write("Connected to network.").Write(CRLF)
				Astream.Write(r).Write(CRLF)
				Astream.Write("ESP8266 IP address: ").Write(Main.WiFi.LocalIp)
			Else
				Astream.Write("Not connected!")
			End If
    	Else
			Astream.Write("HTTP/1.1 404").Write(CRLF)
		End If
		Log("wen son")
		CallSubPlus("CloseConnection", 200, 0)
	End If
End Sub

Private Sub ConnectWifi(u As Byte)
	Log("***Private sub ConnectWifi")
	Main.ConnectToNetwork
End Sub

Private Sub CloseConnection(u As Byte)
	Log("***Private sub closeconnection")
	If server.Socket.Connected Then
		server.Socket.Stream.Flush
		server.Socket.Close
	End If
End Sub

Private Sub AStream_Error
	Log("***Private Sub AStream_Error")
	Log("Disconnected",ethClient.Stream.BytesAvailable)
	
	server.Listen
End Sub

Public Sub ReplaceString(Original() As Byte, SearchFor() As Byte, ReplaceWith() As Byte) As Byte()
	'count number of occurrences
	Log("***Public Sub ReplaceString")
	Dim bc2 As ByteConverter
	Dim c As Int = 0
	Dim i As Int
	If SearchFor.Length <> ReplaceWith.Length Then
		i = bc2.IndexOf(Original, SearchFor)
		Do While i > -1 
			c = c + 1
			i = bc2.IndexOf2(Original, SearchFor, i + SearchFor.Length)
		Loop
	End If
	Dim result(Original.Length + c * (ReplaceWith.Length - SearchFor.Length)) As Byte
	Dim prevIndex As Int = 0
	Dim targetIndex As Int = 0
	i = bc2.IndexOf(Original, SearchFor)
	Do While i > -1 
		bc2.ArrayCopy2(Original, prevIndex, result, targetIndex, i - prevIndex)
		targetIndex = targetIndex + i - prevIndex
		bc2.ArrayCopy2(ReplaceWith, 0, result, targetIndex, ReplaceWith.Length)
		targetIndex = targetIndex + ReplaceWith.Length
		prevIndex = i + SearchFor.Length
		i = bc2.IndexOf2(Original, SearchFor, prevIndex)
	Loop
	If prevIndex < Original.Length Then
		bc2.ArrayCopy2(Original, prevIndex, result, targetIndex, Original.Length - prevIndex)
	End If
	Return result
End Sub


Public Sub ReadSSID As Boolean
	Log("***Public Sub ReadSSID")
	Dim SSID As String ="-"
	Dim header() As Byte = eeprom.ReadBytes(0, 2)
	If header(0) = MAGIC_EEPROM Then
		Dim data() As Byte = eeprom.ReadBytes(2, header(1))
		Dim i As Int = bc.IndexOf(data, Array As Byte(0))
		If i = -1 Then
			Log("Error parsing network data.for read ssid")
			bc.ArrayCopy(bc.StringToBytes("-"),Main.Merkez_wifi_SSID)
			Return False
		End If
		'SSID = bc.StringFromBytes(bc.SubString2(data, 0, i))
		bc.ArrayCopy(bc.SubString2(data,0,i),Main.Merkez_wifi_SSID)
		'Dim Password As String = bc.StringFromBytes(bc.SubString(data, i + 1))		
	Else
		Log("Network data not found.for read ssid")
		'SSID="-"
		bc.ArrayCopy(bc.StringToBytes("-"),Main.Merkez_wifi_SSID)
		Return False
	End If
	Return True
End Sub
Public Sub xReadPassword As String
	Dim Password As String="-"
	Dim header() As Byte = eeprom.ReadBytes(0, 2)
	If header(0) = MAGIC_EEPROM Then
		Dim data() As Byte = eeprom.ReadBytes(2, header(1))
		Dim i As Int = bc.IndexOf(data, Array As Byte(0))
		If i = -1 Then
			Log("Error parsing network data . for read pass")
			Return "-"
		End If
		'SSID = bc.StringFromBytes(bc.SubString2(data, 0, i))
		Password = bc.StringFromBytes(bc.SubString(data, i + 1))		
	Else
		Log("Network data not found. for read pass")
		Password="-"
	End If
	Return Password
End Sub

Public Sub ReadPassword As Boolean
	'Dim Password As String="-"
	Log("***Public Sub ReadPassword")
	Dim header() As Byte = eeprom.ReadBytes(0, 2)
	If header(0) = MAGIC_EEPROM Then
		Dim data() As Byte = eeprom.ReadBytes(2, header(1))
		Dim i As Int = bc.IndexOf(data, Array As Byte(0))
		If i = -1 Then
			Log("Error parsing network data . for read pass")
			bc.ArrayCopy(bc.StringToBytes("-"),Main.Merkez_wifi_Pass)
			Return False
		End If
		'SSID = bc.StringFromBytes(bc.SubString2(data, 0, i))
		bc.ArrayCopy(bc.SubString(data,i+1), Main.Merkez_wifi_Pass)
		'Password = bc.StringFromBytes(bc.SubString(data, i + 1))		
	Else
		Log("Network data not found. for read pass")
		bc.ArrayCopy(bc.StringToBytes("-"),Main.Merkez_wifi_Pass)
		Return False
	End If
	Return True
End Sub
Public Sub SaveNetworkDetails(SSID() As Byte, Password() As Byte)
	'Log(
	Log("***Public Sub SaveNetworkDetails: ", SSID, ", ", Password)
	'SSID = bc.StringFromBytes(ReplaceString(SSID, "%20", " "))
	SSID = (ReplaceString(SSID, "%20", " "))
	eeprom.WriteBytes(Array As Byte(MAGIC_EEPROM, SSID.Length + 1 + Password.Length), 0)
	Dim pos As Int = 2
	eeprom.WriteBytes(SSID, pos)
	pos = pos + SSID.Length
	eeprom.WriteBytes(Array As Byte(0), pos)
	pos = pos + 1
	eeprom.WriteBytes(Password, pos)
	ReadPassword
	ReadSSID
	
End Sub

Public Sub Read32(StartPositon As Int) As Boolean
	Log("***Public Sub Read32")
	Dim x() As Byte ="-"
	Dim header() As Byte = eeprom.ReadBytes(StartPositon*32, 2)
	If header(0) = MAGIC_EEPROM Then
		Dim data() As Byte = eeprom.ReadBytes(StartPositon*32+2, header(1))
	x = data'bc.StringFromBytes(data)'(bc.SubString2(data, 0, i))
	Log("Resad32> ", eeprom.ReadBytes(StartPositon*32, 32))
	Else
		Log("Network data not found.")
		data=bc.StringToBytes("-")
	End If
	Select StartPositon
		Case 1
			bc.ArrayCopy(data, Main.Makine1)
		Case 2
			bc.ArrayCopy(data, Main.Makine2)
		Case 3
			bc.ArrayCopy(data, Main.Merkez_wifi_SSID)
		Case 4
			bc.ArrayCopy(data, Main.Merkez_wifi_Pass)
		Case Else
			Return False
	End Select
	
	Return True
End Sub

Public Sub Write32(data() As Byte,StartPositon As Int) As Boolean
	Log("***Public Sub Write32")
	If data.Length>30 Then Return False
	eeprom.WriteBytes(Array As Byte(MAGIC_EEPROM,data.Length),StartPositon*32)
	eeprom.WriteBytes(data,StartPositon*32+2)
	
	Read32(StartPositon)
	Log("write32-3")
	Return True
End Sub